<script setup lang="ts">
/* import each learning module template */
import learn_1 from './learn/learn-1.vue';
import learn_2 from './learn/learn-2.vue';
import learn_3 from './learn/learn-3.vue';
import learn_4 from './learn/learn-4.vue';
import learn_5 from './learn/learn-5.vue';
import learn_6 from './learn/learn-6.vue';

import { ref } from 'vue';

/* mod1-3 are the buttons */
const mod1 = ref(['mod1', 'is-active']);
const mod2 = ref(['mod2', '']);
const mod3 = ref(['mod3', '']);
const mod4 = ref(['mod4', '']);
const mod5 = ref(['mod5', '']);
const mod6 = ref(['mod6', '']);
/* learn1-3 are the divs containing the templates */
const learn1 = ref(['learn1', 'mod1', '']);
const learn2 = ref(['learn2', 'mod2', 'hide']);
const learn3 = ref(['learn3', 'mod3', 'hide']);
const learn4 = ref(['learn4', 'mod4', 'hide']);
const learn5 = ref(['learn5', 'mod5', 'hide']);
const learn6 = ref(['learn6', 'mod6', 'hide']);
/* array of modules to loop through for toggling */
const mods = ref([
   mod1,
   mod2,
   mod3,
   mod4,
   mod5,
   mod6,
   learn1,
   learn2,
   learn3,
   learn4,
   learn5,
   learn6,
]);

/*------------------------------------------------------------
toggleModule
Passes back the is-active class or a blank string
------------------------------------------------------------*/
function toggleModule(module: string, isActive: boolean) {
   module = isActive ? 'is-active' : '';
   return module;
}

/*------------------------------------------------------------
toggleModuleDiv
Passes back the hide class or a blank string
------------------------------------------------------------*/
function toggleModuleDiv(module: string, isActive: boolean) {
   module = isActive ? '' : 'hide';
   return module;
}

/*------------------------------------------------------------
toggleSelected
input: event trigger
Loops through the array of learning modules and toggles
display classes
------------------------------------------------------------*/
function toggleSelected(e: Event) {
   if (e.target === null) return;

   mods.value.forEach((element) => {
      if (e.target === null) return;

      /* toggle on or off the module buttons */
      if (element.value[0].startsWith('mod')) {
         /* toggle on */
         if (e.target.id == element.value[0])
            element.value[1] = toggleModule(element.value[0], true);
         else
            element.value[1] = toggleModule(
               element.value[0],
               false
            ); /* toggle off */
      } else {
         /* toggle module view */
         /* toggle on */
         if (e.target.id == element.value[1])
            element.value[2] = toggleModuleDiv(
               element.value[1],
               true
            );
         else
            element.value[2] = toggleModuleDiv(
               element.value[1],
               false
            ); /* toggle off */
      }
   });
}
</script>

<template>
   <main>
      <!------------------------------------------------------------
    Tabs Display
    Buttons for toggling the learning module divs
    In rows of 4. Start a new tabs div for every 4.
    Should attempt to render as a list sing Vue
    ------------------------------------------------------------->
      <div
         class="tabs is-center is-fullwidth is-boxed is-toggle block"
      >
         <ul>
            <li :class="mod1">
               <a @click="toggleSelected" id="mod1">
                  Learning Module 1</a
               >
            </li>
            <li :class="mod2">
               <a @click="toggleSelected" id="mod2">
                  Learning Module 2</a
               >
            </li>
            <li :class="mod3">
               <a @click="toggleSelected" id="mod3">
                  Learning Module 3</a
               >
            </li>
            <li :class="mod4">
               <a @click="toggleSelected" id="mod4">
                  Learning Module 4</a
               >
            </li>
         </ul>
      </div>
      <div
         class="tabs is-center is-fullwidth is-boxed is-toggle block"
      >
         <ul>
            <li :class="mod5">
               <a @click="toggleSelected" id="mod5">
                  Learning Module 5</a
               >
            </li>
            <li :class="mod6">
               <a @click="toggleSelected" id="mod6">
                  Learning Module 6</a
               >
            </li>
         </ul>
      </div>
      <!------------------------------------------------------------
    Learning Module Divs
    Displays the learning module templates
    ------------------------------------------------------------->
      <div :class="learn1" class="block">
         <learn_1 />
      </div>
      <div :class="learn2" class="block">
         <learn_2 />
      </div>
      <div :class="learn3" class="block">
         <learn_3 />
      </div>
      <div :class="learn4" class="block">
         <learn_4 />
      </div>
      <div :class="learn5" class="block">
         <learn_5 />
      </div>
      <div :class="learn6" class="block">
         <learn_6 />
      </div>
   </main>
</template>
